<!-- This file was generated by pybib2web, version 0.7.dev0: https://gitlab.com/sosy-lab/software/pybib2web/ -->
<input type="checkbox" id="show-compact">
<label for="show-compact">Compact view</label>
<h2 id="publications">Publications of Thomas Lemberger</h2>
<nav class="publication-navigation">(<a href="../All/index.html">Show all</a> &ndash; <a href="../index.html">Index</a>)</nav>

<a href="../Category/conferences.html"><h3>Articles in conference or workshop proceedings</h3></a>

<ol class="list-publications" start="1">

<li class="bibentry" id="ICSE22">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Jan</span> <span class="lastname">Haltermann</span></span>,
    <span class="author"><a href="../Author/LEMBERGER-T.html"><span class="firstname">Thomas</span> <span class="lastname">Lemberger</span></a></span>, and
    <span class="author"><span class="firstname">Heike</span> <span class="lastname">Wehrheim</span></span>.</span>
    <span class="publication-title">Decomposing Software Verification into Off-the-Shelf Components: An Application to CEGAR.</span>
    <span class="howpublished">
      In <em class="booktitle">  Proceedings of the 44th International Conference on
        Software Engineering (ICSE 2022, Pittsburgh, PA, USA, May 8-20 (Virtual), May 22-27 (In-Person))</em>,
      <span class="publication-date">  <span class="year">2022</span></span>.
    </span>
    <span class="publisher">ACM.</span>
  </span>
  <a class="bibentry-link" href="#ICSE22"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/CPACHECKER.html">CPAchecker</a>,
        <a class="keyword" href="../Keyword/SOFTWARE-MODEL-CHECKING.html">Software Model Checking</a>,
        <a class="keyword" href="../Keyword/INTERFACES-FOR-COMPONENT-BASED-DESIGN.html">Interfaces for Component-Based Design</a>
      </span>
      <span class="funding-list">Funding:
        <a class="funding" href="../Funding/DFG-COOP.html">DFG-COOP</a>
      </span>
    </span>
    <span class="link-list">
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2022-ICSE.Decomposing_Software_Verification_into_Off-the-Shelf-Components.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="material-link" href="https://www.sosy-lab.org/research/component-based-cegar/"><img alt="" height="15px" width="15px" src="https://www.sosy-lab.org/research/pub/Icons/www.gif">Supplement</a>
    </span>
    <details  class="artifact-list">
      <summary>Artifact(s)</summary>
      <div>
        <ol>
          <li class="artifact"><a href="https://doi.org/10.5281/zenodo.5301636">doi:10.5281/zenodo.5301636</a></li>
        </ol>
      </div>
    </details>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        Techniques for software verification are typically realized as cohesive units of software with tightly coupled components.
        This makes it difficult to re-use components, and the potential for workload distribution is limited.
        Innovations in software verification might find their way into practice faster if provided in smaller,
        more specialized components.
        In this paper, we propose to strictly decompose software verification: 
        the verification task is split into independent subtasks, implemented by only loosely coupled components 
        communicating via clearly defined interfaces. 
        We apply this decomposition concept to one of the most frequently employed techniques
        in software verification:
        counterexample-guided abstraction refinement (CEGAR).
        CEGAR is a technique to iteratively compute
        an abstract model of the system.
        We develop a decomposition of CEGAR into independent components
        with clearly defined interfaces that are based on existing, standardized exchange formats.
        Its realization component-based CEGAR (C-CEGAR) concerns the three core tasks of CEGAR:
        abstract-model exploration, feasibility check, and precision refinement.
        We experimentally show that - despite the necessity of exchanging complex data via interfaces -
        the efficiency thereby only reduces by a small constant factor while the precision in solving verification tasks even increases. 
        We furthermore illustrate the advantages of C-CEGAR by experimenting with 
        different implementations of components, thereby further increasing the overall effectiveness
        and testing that substitution of components works well.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{ICSE22,
        author = {Dirk Beyer and Jan Haltermann and Thomas Lemberger and Heike Wehrheim},
        title = {Decomposing Software Verification into Off-the-Shelf Components: An Application to {CEGAR}},
        booktitle = {Proceedings of the 44th International Conference on Software Engineering (ICSE~2022, Pittsburgh, PA, USA, May 8-20 (Virtual), May 22-27 (In-Person))},
        year = {2022},
        publisher = {ACM},
        url = {https://www.sosy-lab.org/research/component-based-cegar/},
        pdf = {https://www.sosy-lab.org/research/pub/2022-ICSE.Decomposing_Software_Verification_into_Off-the-Shelf-Components.pdf},
        abstract = {Techniques for software verification are typically realized as cohesive units of software with tightly coupled components. This makes it difficult to re-use components, and the potential for workload distribution is limited. Innovations in software verification might find their way into practice faster if provided in smaller, more specialized components. In this paper, we propose to strictly decompose software verification:  the verification task is split into independent subtasks, implemented by only loosely coupled components  communicating via clearly defined interfaces.  We apply this decomposition concept to one of the most frequently employed techniques in software verification: counterexample-guided abstraction refinement (CEGAR). CEGAR is a technique to iteratively compute an abstract model of the system. We develop a decomposition of CEGAR into independent components with clearly defined interfaces that are based on existing, standardized exchange formats. Its realization component-based CEGAR (C-CEGAR) concerns the three core tasks of CEGAR: abstract-model exploration, feasibility check, and precision refinement. We experimentally show that --- despite the necessity of exchanging complex data via interfaces --- the efficiency thereby only reduces by a small constant factor while the precision in solving verification tasks even increases.  We furthermore illustrate the advantages of C-CEGAR by experimenting with  different implementations of components, thereby further increasing the overall effectiveness and testing that substitution of components works well.},
        keyword = {CPAchecker,Software Model Checking,Interfaces for Component-Based Design},
        artifact = {10.5281/zenodo.5301636},
        doinone = {Unpublished: Last checked: 2022-02-19},
        funding = {DFG-COOP},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="SEFM20b">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><a href="../Author/JAKOBS-M.html"><span class="firstname">Marie-Christine</span> <span class="lastname">Jakobs</span></a></span>, and
    <span class="author"><a href="../Author/LEMBERGER-T.html"><span class="firstname">Thomas</span> <span class="lastname">Lemberger</span></a></span>.</span>
    <span class="publication-title">Difference Verification with Conditions.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">F. d.</span> <span class="lastname">Boer</span></span> and
      <span class="editor"><span class="firstname">A.</span> <span class="lastname">Cerone</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 18th International Conference on
        Software Engineering and Formal Methods (SEFM 2020, Virtual, Netherlands, September 14-18)</em>,
      <span class="series">LNCS 12310</span>,
      <span class="pages">pages 133-154</span>,
      <span class="publication-date">  <span class="year">2020</span></span>.
    </span>
    <span class="publisher">Springer.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-030-58768-0_8" data-doi="10.1007/978-3-030-58768-0_8" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-030-58768-0_8</a>
  </span>
  <a class="bibentry-link" href="#SEFM20b"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/CPACHECKER.html">CPAchecker</a>,
        <a class="keyword" href="../Keyword/SOFTWARE-MODEL-CHECKING.html">Software Model Checking</a>
      </span>
      <span class="funding-list">Funding:
        <a class="funding" href="../Funding/DFG-COOP.html">DFG-COOP</a>,
        <a class="funding" href="../Funding/DFG-CONVEY.html">DFG-CONVEY</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-030-58768-0_8" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://link.springer.com/content/pdf/10.1007/978-3-030-58768-0_8.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="presentation-link" href="https://www.sosy-lab.org/research/prs/2020-09-17_SEFM20_DifferenceVerificationWithConditions_Thomas.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/presentation.gif">Presentation</a>
      <a class="video-link" href="https://youtu.be/dG02602c9oo" title="Link to video presentation related to paper"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/video.gif">Video</a>
      <a class="material-link" href="https://www.sosy-lab.org/research/difference/"><img alt="" height="15px" width="15px" src="https://www.sosy-lab.org/research/pub/Icons/www.gif">Supplement</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        Modern software-verification tools need to support development processes that involve frequent changes.
        Existing approaches for incremental verification hard-code specific verification techniques.
        Some of the approaches must be tightly intertwined with the development process.
        To solve this open problem, we present the concept of difference verification with conditions.
        Difference verification with conditions is independent from any specific verification technique
        and can be integrated in software projects at any time.
        It first applies a change analysis that detects which parts of a software were changed
        between revisions and encodes that information in a condition.
        Based on this condition, an off-the-shelf verifier is used to verify only those parts
        of the software that are influenced by the changes.
        As a proof of concept, we propose a simple, syntax-based change analysis
        and use difference verification with conditions with three off-the-shelf verifiers.
        An extensive evaluation shows the competitiveness of difference verification with conditions.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{SEFM20b,
        author = {Dirk Beyer and Marie-Christine Jakobs and Thomas Lemberger},
        title = {Difference Verification with Conditions},
        booktitle = {Proceedings of the 18th International Conference on Software Engineering and Formal Methods (SEFM~2020, Virtual, Netherlands, September 14-18)},
        editor = {F.~d.~Boer and A.~Cerone},
        pages = {133--154},
        year = {2020},
        series = {LNCS~12310},
        publisher = {Springer},
        doi = {10.1007/978-3-030-58768-0_8},
        sha256 = {8e5219da9a998b26f59013c809fbb1db6f92e3f08125fa1bfaacafcfafafef7f},
        url = {https://www.sosy-lab.org/research/difference/},
        presentation = {https://www.sosy-lab.org/research/prs/2020-09-17_SEFM20_DifferenceVerificationWithConditions_Thomas.pdf},
        abstract = {Modern software-verification tools need to support development processes that involve frequent changes. Existing approaches for incremental verification hard-code specific verification techniques. Some of the approaches must be tightly intertwined with the development process. To solve this open problem, we present the concept of difference verification with conditions. Difference verification with conditions is independent from any specific verification technique and can be integrated in software projects at any time. It first applies a change analysis that detects which parts of a software were changed between revisions and encodes that information in a condition. Based on this condition, an off-the-shelf verifier is used to verify only those parts of the software that are influenced by the changes. As a proof of concept, we propose a simple, syntax-based change analysis and use difference verification with conditions with three off-the-shelf verifiers. An extensive evaluation shows the competitiveness of difference verification with conditions.},
        keyword = {CPAchecker,Software Model Checking},
        funding = {DFG-COOP,DFG-CONVEY},
        isbnnote = {},
        video = {https://youtu.be/dG02602c9oo},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="ASE19">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span> and
    <span class="author"><a href="../Author/LEMBERGER-T.html"><span class="firstname">Thomas</span> <span class="lastname">Lemberger</span></a></span>.</span>
    <span class="publication-title">TestCov: Robust Test-Suite Execution and Coverage Measurement.</span>
    <span class="howpublished">
      In <em class="booktitle">  Proceedings of the 34th IEEE/ACM International Conference on Automated Software Engineering (ASE 2019, San Diego, CA, USA, November 11-15)</em>,
      <span class="pages">pages 1074-1077</span>,
      <span class="publication-date">  <span class="year">2019</span></span>.
    </span>
    <span class="publisher">IEEE.</span>
    <a class="doi" href="https://doi.org/10.1109/ASE.2019.00105" data-doi="10.1109/ASE.2019.00105" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1109/ASE.2019.00105</a>
  </span>
  <a class="bibentry-link" href="#ASE19"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/DFG-COOP.html">DFG-COOP</a>,
        <a class="keyword" href="../Keyword/SOFTWARE-TESTING.html">Software Testing</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1109/ASE.2019.00105" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2019-ASE.TestCov_Robust_Test-Suite_Execution_and_Coverage_Measurement.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="presentation-link" href="https://www.sosy-lab.org/research/prs/2019-11-12_ASE19_TestCov_Thomas_Lemberger.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/presentation.gif">Presentation</a>
    </span>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{ASE19,
        author = {Dirk Beyer and Thomas Lemberger},
        title = {{T}est{C}ov: Robust Test-Suite Execution and Coverage Measurement},
        booktitle = {Proceedings of the 34th IEEE/ACM International Conference on Automated Software Engineering (ASE 2019, San Diego, CA, USA, November 11-15)},
        pages = {1074-1077},
        year = {2019},
        publisher = {IEEE},
        doi = {10.1109/ASE.2019.00105},
        sha256 = {},
        pdf = {https://www.sosy-lab.org/research/pub/2019-ASE.TestCov_Robust_Test-Suite_Execution_and_Coverage_Measurement.pdf},
        presentation = {https://www.sosy-lab.org/research/prs/2019-11-12_ASE19_TestCov_Thomas_Lemberger.pdf},
        keyword = {DFG-COOP,Software Testing},
        isbnnote = {978-1-7281-2508-4},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="ATVA19">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span> and
    <span class="author"><a href="../Author/LEMBERGER-T.html"><span class="firstname">Thomas</span> <span class="lastname">Lemberger</span></a></span>.</span>
    <span class="publication-title">Conditional Testing - Off-the-Shelf Combination of Test-Case Generators.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">Yu-Fang</span> <span class="lastname">Chen</span></span>,
      <span class="editor"><span class="firstname">Chih-Hong</span> <span class="lastname">Cheng</span></span>, and
      <span class="editor"><span class="firstname">Javier</span> <span class="lastname">Esparza</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 17th International Symposium on
        Automated Technology for Verification and Analysis (ATVA 2019, Taipei, Taiwan, October 28-31)</em>,
      <span class="series">LNCS 11781</span>,
      <span class="pages">pages 189-208</span>,
      <span class="publication-date">  <span class="year">2019</span></span>.
    </span>
    <span class="publisher">Springer.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-030-31784-3_11" data-doi="10.1007/978-3-030-31784-3_11" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-030-31784-3_11</a>
  </span>
  <a class="bibentry-link" href="#ATVA19"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/DFG-COOP.html">DFG-COOP</a>,
        <a class="keyword" href="../Keyword/SOFTWARE-TESTING.html">Software Testing</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-030-31784-3_11" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2019-ATVA.Conditional_Testing_Off-the-Shelf_Combination_of_Test-Case_Generators.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="presentation-link" href="https://www.sosy-lab.org/research/prs/2019-10-29_ATVA19_Conditional_Testing_Thomas_Lemberger.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/presentation.gif">Presentation</a>
      <a class="material-link" href="https://www.sosy-lab.org/research/conditional-testing/"><img alt="" height="15px" width="15px" src="https://www.sosy-lab.org/research/pub/Icons/www.gif">Supplement</a>
    </span>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{ATVA19,
        author = {Dirk Beyer and Thomas Lemberger},
        title = {Conditional Testing - Off-the-Shelf Combination of Test-Case Generators},
        booktitle = {Proceedings of the 17th International Symposium on Automated Technology for Verification and Analysis (ATVA~2019, Taipei, Taiwan, October 28-31)},
        editor = {Yu{-}Fang Chen and Chih{-}Hong Cheng and Javier Esparza},
        pages = {189-208},
        year = {2019},
        series = {LNCS~11781},
        publisher = {Springer},
        doi = {10.1007/978-3-030-31784-3_11},
        sha256 = {},
        url = {https://www.sosy-lab.org/research/conditional-testing/},
        pdf = {https://www.sosy-lab.org/research/pub/2019-ATVA.Conditional_Testing_Off-the-Shelf_Combination_of_Test-Case_Generators.pdf},
        presentation = {https://www.sosy-lab.org/research/prs/2019-10-29_ATVA19_Conditional_Testing_Thomas_Lemberger.pdf},
        keyword = {DFG-COOP,Software Testing},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="SE19">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><a href="../Author/JAKOBS-M.html"><span class="firstname">Marie-Christine</span> <span class="lastname">Jakobs</span></a></span>,
    <span class="author"><a href="../Author/LEMBERGER-T.html"><span class="firstname">Thomas</span> <span class="lastname">Lemberger</span></a></span>, and
    <span class="author"><span class="firstname">Heike</span> <span class="lastname">Wehrheim</span></span>.</span>
    <span class="publication-title">Combining Verifiers in Conditional Model Checking via Reducers.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">S.</span> <span class="lastname">Becker</span></span>,
      <span class="editor"><span class="firstname">I.</span> <span class="lastname">Bogicevic</span></span>,
      <span class="editor"><span class="firstname">G.</span> <span class="lastname">Herzwurm</span></span>, and
      <span class="editor"><span class="firstname">S.</span> <span class="lastname">Wagner</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the Conference on
        Software Engineering and Software Management (SE/SWM 2019, Stuttgart, Germany, February 18-22)</em>,
      <span class="series">LNI P-292</span>,
      <span class="pages">pages 151-152</span>,
      <span class="publication-date">  <span class="year">2019</span></span>.
    </span>
    <span class="publisher">GI.</span>
    <a class="doi" href="https://doi.org/10.18420/se2019-46" data-doi="10.18420/se2019-46" title="The digital object identifier permanently identifies a digital article or document.">doi:10.18420/se2019-46</a>
  </span>
  <a class="bibentry-link" href="#SE19"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/CPACHECKER.html">CPAchecker</a>,
        <a class="keyword" href="../Keyword/SOFTWARE-MODEL-CHECKING.html">Software Model Checking</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.18420/se2019-46" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2019-SE.Combining_Verifiers_in_Conditional_Model_Checking_via_Reducers.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="presentation-link" href="https://www.sosy-lab.org/research/prs/2019-02-22_SE19_CombiningVerifiersInConditionalModelChecking_Marie.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/presentation.gif">Presentation</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        Software verification received lots of attention in the past two decades.
        Nonetheless, it remains an extremely difficult problem.
        Some verification tasks cannot be solved automatically by any of today’s verifiers.
        To still verify such tasks, one can combine the strengths of different verifiers.
        A promising approach to create combinations is conditional model checking (CMC).
        In CMC, the first verifier outputs a condition that describes
        the parts of the program state space that it successfully verified,
        and the next verifier uses that condition to steer its exploration towards
        the unverified state space.
        Despite the benefits of CMC, only few verifiers can handle conditions.
        To overcome this problem, we propose an automatic plug-and-play extension
        for verifiers. Instead of modifying verifiers, we suggest to add a preprocessor:
        the reducer.
        The reducer takes the condition and the original program and computes
        a residual program that encodes the unverified state space in program code.
        We developed one such reducer and use it to integrate existing verifiers
        and test-case generators into the CMC process.
        Our experiments show that we can solve many additional verification tasks
        with this reducer-based construction.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{SE19,
        author = {Dirk Beyer and Marie-Christine Jakobs and Thomas Lemberger and Heike Wehrheim},
        title = {Combining Verifiers in Conditional Model Checking via Reducers},
        booktitle = {Proceedings of the Conference on Software Engineering and Software Management (SE/SWM~2019, Stuttgart, Germany, February 18-22)},
        editor = {S.~Becker and I.~Bogicevic and G.~Herzwurm and S.~Wagner},
        pages = {151--152},
        year = {2019},
        series = {{LNI}~P-292},
        publisher = {{GI}},
        doi = {10.18420/se2019-46},
        sha256 = {},
        pdf = {https://www.sosy-lab.org/research/pub/2019-SE.Combining_Verifiers_in_Conditional_Model_Checking_via_Reducers.pdf},
        presentation = {https://www.sosy-lab.org/research/prs/2019-02-22_SE19_CombiningVerifiersInConditionalModelChecking_Marie.pdf},
        abstract = {Software verification received lots of attention in the past two decades. Nonetheless, it remains an extremely difficult problem. Some verification tasks cannot be solved automatically by any of today’s verifiers. To still verify such tasks, one can combine the strengths of different verifiers. A promising approach to create combinations is conditional model checking (CMC). In CMC, the first verifier outputs a condition that describes the parts of the program state space that it successfully verified, and the next verifier uses that condition to steer its exploration towards the unverified state space. Despite the benefits of CMC, only few verifiers can handle conditions. To overcome this problem, we propose an automatic plug-and-play extension for verifiers. Instead of modifying verifiers, we suggest to add a preprocessor: the reducer. The reducer takes the condition and the original program and computes a residual program that encodes the unverified state space in program code. We developed one such reducer and use it to integrate existing verifiers and test-case generators into the CMC process. Our experiments show that we can solve many additional verification tasks with this reducer-based construction.},
        keyword = {CPAchecker,Software Model Checking},
        annote = {This is a summary of a &lt;a href=&quot;https://www.sosy-lab.org/research/bib/Year/2018.html#ICSE18&quot;&gt;full article on this topic&lt;/a&gt; that appeared in Proc. ICSE 2018.},
        }
        
      </div>
    </details>
    <details open class="annote">
      <summary>Additional Infos</summary>
      <div>
        This is a summary of a <a href="https://www.sosy-lab.org/research/bib/Year/2018.html#ICSE18">full article on this topic</a> that appeared in Proc. ICSE 2018.
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="ASE18b">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span> and
    <span class="author"><a href="../Author/LEMBERGER-T.html"><span class="firstname">Thomas</span> <span class="lastname">Lemberger</span></a></span>.</span>
    <span class="publication-title">CPA-SymExec: Efficient Symbolic Execution in CPAchecker.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">Marianne</span> <span class="lastname">Huchard</span></span>,
      <span class="editor"><span class="firstname">Christian</span> <span class="lastname">Kästner</span></span>, and
      <span class="editor"><span class="firstname">Gordon</span> <span class="lastname">Fraser</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 33rd ACM/IEEE International Conference on Automated
        Software Engineering (ASE 2018, Montpellier, France, September 3-7)</em>,
      <span class="pages">pages 900-903</span>,
      <span class="publication-date">  <span class="year">2018</span></span>.
    </span>
    <span class="publisher">ACM.</span>
    <a class="doi" href="https://doi.org/10.1145/3238147.3240478" data-doi="10.1145/3238147.3240478" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1145/3238147.3240478</a>
  </span>
  <a class="bibentry-link" href="#ASE18b"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/CPACHECKER.html">CPAchecker</a>,
        <a class="keyword" href="../Keyword/SOFTWARE-MODEL-CHECKING.html">Software Model Checking</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1145/3238147.3240478" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2018-ASE.CPA-SymExec_Efficient_Symbolic_Execution_in_CPAchecker.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="presentation-link" href="https://www.sosy-lab.org/research/prs/2018-09-07_ASE18_CPASymExec_Thomas.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/presentation.gif">Presentation</a>
      <a class="video-link" href="https://youtu.be/7o7EtpbV8NM" title="Link to video presentation related to paper"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/video.gif">Video</a>
      <a class="material-link" href="https://www.sosy-lab.org/research/cpa-symexec-tool/"><img alt="" height="15px" width="15px" src="https://www.sosy-lab.org/research/pub/Icons/www.gif">Supplement</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        We present CPA-SymExec, a tool for symbolic execution that is implemented
        in the open-source, configurable verification framework
        CPAchecker. Our implementation automatically detects which symbolic
        facts to track, in order to obtain a small set of constraints that
        are necessary to decide reachability of a program area of interest.
        CPA-SymExec is based on abstraction and counterexample-guided abstraction
        refinement (CEGAR), and uses a constraint-interpolation
        approach to detect symbolic facts. We show that our implementation
        can better mitigate the path-explosion problem than symbolic
        execution without abstraction, by comparing the performance to
        the state-of-the-art Klee-based symbolic-execution engine Symbiotic
        and to Klee itself. For the experiments we use two kinds of
        analysis tasks: one for finding an executable path to a specific
        location of interest (e.g., if a test vector is desired to show that
        a certain behavior occurs), and one for confirming that no executable
        path to a specific location exists (e.g., if it is desired to show
        that a certain behavior never occurs). CPA-SymExec is released under
        the Apache 2 license and available (inclusive source code) at
        https://cpachecker.sosy-lab.org. A demonstration video is available
        at https://youtu.be/qoBHtvPKtnw.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{ASE18b,
        author = {Dirk Beyer and Thomas Lemberger},
        title = {{CPA-SymExec}: Efficient Symbolic Execution in {CPAchecker}},
        booktitle = {Proceedings of the 33rd {ACM/IEEE} International Conference on Automated Software Engineering ({ASE}~2018, Montpellier, France, September 3-7)},
        editor = {Marianne Huchard and Christian K{\&quot;{a}}stner and Gordon Fraser},
        pages = {900-903},
        year = {2018},
        publisher = {ACM},
        doi = {10.1145/3238147.3240478},
        sha256 = {},
        url = {https://www.sosy-lab.org/research/cpa-symexec-tool/},
        pdf = {https://www.sosy-lab.org/research/pub/2018-ASE.CPA-SymExec_Efficient_Symbolic_Execution_in_CPAchecker.pdf},
        presentation = {https://www.sosy-lab.org/research/prs/2018-09-07_ASE18_CPASymExec_Thomas.pdf},
        abstract = {We present CPA-SymExec, a tool for symbolic execution that is implemented in the open-source, configurable verification framework CPAchecker. Our implementation automatically detects which symbolic facts to track, in order to obtain a small set of constraints that are necessary to decide reachability of a program area of interest. CPA-SymExec is based on abstraction and counterexample-guided abstraction refinement (CEGAR), and uses a constraint-interpolation approach to detect symbolic facts. We show that our implementation can better mitigate the path-explosion problem than symbolic execution without abstraction, by comparing the performance to the state-of-the-art Klee-based symbolic-execution engine Symbiotic and to Klee itself. For the experiments we use two kinds of analysis tasks: one for finding an executable path to a specific location of interest (e.g., if a test vector is desired to show that a certain behavior occurs), and one for confirming that no executable path to a specific location exists (e.g., if it is desired to show that a certain behavior never occurs). CPA-SymExec is released under the Apache 2 license and available (inclusive source code) at https://cpachecker.sosy-lab.org. A demonstration video is available at https://youtu.be/qoBHtvPKtnw.},
        keyword = {CPAchecker,Software Model Checking},
        video = {https://youtu.be/7o7EtpbV8NM},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="TAP18">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><a href="../Author/DANGL-M.html"><span class="firstname">Matthias</span> <span class="lastname">Dangl</span></a></span>,
    <span class="author"><a href="../Author/LEMBERGER-T.html"><span class="firstname">Thomas</span> <span class="lastname">Lemberger</span></a></span>, and
    <span class="author"><span class="firstname">Michael</span> <span class="lastname">Tautschnig</span></span>.</span>
    <span class="publication-title">Tests from Witnesses: Execution-Based Validation of Verification Results.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">Catherine</span> <span class="lastname">Dubois</span></span> and
      <span class="editor"><span class="firstname">Burkhart</span> <span class="lastname">Wolff</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 12th International Conference on
        Tests and Proofs (TAP 2018, Toulouse, France, June 27-29)</em>,
      <span class="series">LNCS 10889</span>,
      <span class="pages">pages 3-23</span>,
      <span class="publication-date">  <span class="year">2018</span></span>.
    </span>
    <span class="publisher">Springer.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-319-92994-1_1" data-doi="10.1007/978-3-319-92994-1_1" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-319-92994-1_1</a>
  </span>
  <a class="bibentry-link" href="#TAP18"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/CPACHECKER.html">CPAchecker</a>,
        <a class="keyword" href="../Keyword/SOFTWARE-MODEL-CHECKING.html">Software Model Checking</a>,
        <a class="keyword" href="../Keyword/WITNESS-BASED-VALIDATION.html">Witness-Based Validation</a>,
        <a class="keyword" href="../Keyword/WITNESS-BASED-VALIDATION-MAIN.html">Witness-Based Validation (main)</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-319-92994-1_1" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2018-TAP.Tests_from_Witnesses_Execution-Based_Validation_of_Verification_Results.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="presentation-link" href="https://www.sosy-lab.org/research/prs/2018-06-27_TAP18-Keynote-CooperativeVerification_Dirk.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/presentation.gif">Presentation</a>
      <a class="material-link" href="https://www.sosy-lab.org/research/tests-from-witnesses/"><img alt="" height="15px" width="15px" src="https://www.sosy-lab.org/research/pub/Icons/www.gif">Supplement</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        The research community made enormous progress in the past years
        in developing algorithms for verifying software, as shown by
        verification competitions (SV-COMP). However, the ultimate goal
        is to design certifying algorithms, which produce for a given input
        not only the output but in addition a witness. This makes it possible
        to validate that the output is a correct solution for the
        input problem. The advantage of certifying algorithms is that the
        validation of the result is —thanks to the witness— easier than the
        computation of the result. Unfortunately, the transfer to industry
        is slow, one of the reasons being that some verifiers report a
        considerable number of false alarms. The verification community
        works towards this ultimate goal using exchangeable violation
        witnesses, i.e., an independent validator can be used to check
        whether the produced witness indeed represents a bug. This reduces
        the required trust base from the complex verification tool to a
        validator that may be less complex, and thus, more easily trustable.
        But existing witness validators are based on model-checking
        technology — which does not solve the problem of reducing the trust
        base. To close this gap, we present a simple concept that is based
        on program execution: We extend witness validation by generating
        a test vector from an error path that is reconstructed from
        the witness. Then, we generate a test harness
        (similar to unit-test code) that can be compiled and linked
        together with the original program. We then run the executable
        program in an isolating container. If the execution violates the
        specification (similar to runtime verification) we confirm that the
        witness indeed represents a bug. This method reduces the trust
        base to the execution system, which seems appropriate for avoiding
        false alarms. To show feasibility and practicality, we implemented
        execution-based witness validation in two completely independent
        analysis frameworks, and performed a large experimental study.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{TAP18,
        author = {Dirk Beyer and Matthias Dangl and Thomas Lemberger and Michael Tautschnig},
        title = {Tests from Witnesses: Execution-Based Validation of Verification Results},
        booktitle = {Proceedings of the 12th International Conference on Tests and Proofs (TAP~2018, Toulouse, France, June 27-29)},
        editor = {Catherine Dubois and Burkhart Wolff},
        pages = {3-23},
        year = {2018},
        series = {LNCS~10889},
        publisher = {Springer},
        doi = {10.1007/978-3-319-92994-1_1},
        sha256 = {},
        url = {https://www.sosy-lab.org/research/tests-from-witnesses/},
        pdf = {https://www.sosy-lab.org/research/pub/2018-TAP.Tests_from_Witnesses_Execution-Based_Validation_of_Verification_Results.pdf},
        presentation = {https://www.sosy-lab.org/research/prs/2018-06-27_TAP18-Keynote-CooperativeVerification_Dirk.pdf},
        abstract = {The research community made enormous progress in the past years in developing algorithms for verifying software, as shown by verification competitions (SV-COMP). However, the ultimate goal is to design certifying algorithms, which produce for a given input not only the output but in addition a witness. This makes it possible to validate that the output is a correct solution for the input problem. The advantage of certifying algorithms is that the validation of the result is —thanks to the witness— easier than the computation of the result. Unfortunately, the transfer to industry is slow, one of the reasons being that some verifiers report a considerable number of false alarms. The verification community works towards this ultimate goal using exchangeable violation witnesses, i.e., an independent validator can be used to check whether the produced witness indeed represents a bug. This reduces the required trust base from the complex verification tool to a validator that may be less complex, and thus, more easily trustable. But existing witness validators are based on model-checking technology — which does not solve the problem of reducing the trust base. To close this gap, we present a simple concept that is based on program execution: We extend witness validation by generating a test vector from an error path that is reconstructed from the witness. Then, we generate a test harness (similar to unit-test code) that can be compiled and linked together with the original program. We then run the executable program in an isolating container. If the execution violates the specification (similar to runtime verification) we confirm that the witness indeed represents a bug. This method reduces the trust base to the execution system, which seems appropriate for avoiding false alarms. To show feasibility and practicality, we implemented execution-based witness validation in two completely independent analysis frameworks, and performed a large experimental study.},
        keyword = {CPAchecker,Software Model Checking,Witness-Based Validation,Witness-Based Validation (main)},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="ICSE18">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><a href="../Author/JAKOBS-M.html"><span class="firstname">Marie-Christine</span> <span class="lastname">Jakobs</span></a></span>,
    <span class="author"><a href="../Author/LEMBERGER-T.html"><span class="firstname">Thomas</span> <span class="lastname">Lemberger</span></a></span>, and
    <span class="author"><span class="firstname">Heike</span> <span class="lastname">Wehrheim</span></span>.</span>
    <span class="publication-title">Reducer-Based Construction of Conditional Verifiers.</span>
    <span class="howpublished">
      In <em class="booktitle">  Proceedings of the 40th International Conference on 
        Software Engineering (ICSE 2018, Gothenburg, Sweden, May 27 - June 3)</em>,
      <span class="pages">pages 1182-1193</span>,
      <span class="publication-date">  <span class="year">2018</span></span>.
    </span>
    <span class="publisher">ACM.</span>
    <a class="doi" href="https://doi.org/10.1145/3180155.3180259" data-doi="10.1145/3180155.3180259" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1145/3180155.3180259</a>
  </span>
  <a class="bibentry-link" href="#ICSE18"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/CPACHECKER.html">CPAchecker</a>,
        <a class="keyword" href="../Keyword/SOFTWARE-MODEL-CHECKING.html">Software Model Checking</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1145/3180155.3180259" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2018-ICSE.Reducer-Based_Construction_of_Conditional_Verifiers.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="presentation-link" href="https://www.sosy-lab.org/research/prs/2018-06-01_ICSE18_ReducerBasedConstructionOfConditionalVerifiers_Marie.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/presentation.gif">Presentation</a>
      <a class="material-link" href="https://www.sosy-lab.org/research/reducer/"><img alt="" height="15px" width="15px" src="https://www.sosy-lab.org/research/pub/Icons/www.gif">Supplement</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        Despite recent advances, software verification remains challenging.
        To solve hard verification tasks, we need to leverage not just one
        but several different verifiers employing different technologies.
        To this end, we need to exchange information between verifiers.
        Conditional model checking was proposed as a solution to exactly
        this problem: The idea is to let the first verifier output a condition
        which describes the state space that it successfully verified and to
        instruct the second verifier to verify the yet unverified state space
        using this condition. However, most verifiers do not understand
        conditions as input.
        In this paper, we propose the usage of an off-the-shelf construction of
        a conditional verifier from a given traditional verifier and a reducer.
        The reducer takes as input the program to be verified and the condition,
        and outputs a residual program whose paths cover the unverified
        state space described by the condition.
        As a proof of concept, we designed and implemented one
        particular reducer and composed three conditional model checkers
        from the three best verifiers at SV-COMP 2017.
        We defined a set of claims and experimentally evaluated their validity.
        All experimental data and results are available for replication.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{ICSE18,
        author = {Dirk Beyer and Marie-Christine Jakobs and Thomas Lemberger and Heike Wehrheim},
        title = {Reducer-Based Construction of Conditional Verifiers},
        booktitle = {Proceedings of the 40th International Conference on  Software Engineering (ICSE~2018, Gothenburg, Sweden, May 27 - June 3)},
        pages = {1182-1193},
        year = {2018},
        publisher = {ACM},
        isbn = {978-1-4503-5638-1},
        doi = {10.1145/3180155.3180259},
        sha256 = {},
        url = {https://www.sosy-lab.org/research/reducer/},
        pdf = {https://www.sosy-lab.org/research/pub/2018-ICSE.Reducer-Based_Construction_of_Conditional_Verifiers.pdf},
        presentation = {https://www.sosy-lab.org/research/prs/2018-06-01_ICSE18_ReducerBasedConstructionOfConditionalVerifiers_Marie.pdf},
        abstract = {Despite recent advances, software verification remains challenging. To solve hard verification tasks, we need to leverage not just one but several different verifiers employing different technologies. To this end, we need to exchange information between verifiers. Conditional model checking was proposed as a solution to exactly this problem: The idea is to let the first verifier output a condition which describes the state space that it successfully verified and to instruct the second verifier to verify the yet unverified state space using this condition. However, most verifiers do not understand conditions as input. In this paper, we propose the usage of an off-the-shelf construction of a conditional verifier from a given traditional verifier and a reducer. The reducer takes as input the program to be verified and the condition, and outputs a residual program whose paths cover the unverified state space described by the condition. As a proof of concept, we designed and implemented one particular reducer and composed three conditional model checkers from the three best verifiers at SV-COMP 2017. We defined a set of claims and experimentally evaluated their validity. All experimental data and results are available for replication.},
        keyword = {CPAchecker,Software Model Checking},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="HVC17">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span> and
    <span class="author"><a href="../Author/LEMBERGER-T.html"><span class="firstname">Thomas</span> <span class="lastname">Lemberger</span></a></span>.</span>
    <span class="publication-title">Software Verification: Testing vs. Model Checking.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">O.</span> <span class="lastname">Strichman</span></span> and
      <span class="editor"><span class="firstname">R.</span> <span class="lastname">Tzoref-Brill</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 13th Haifa Verification Conference (HVC 2017, Haifa, Israel, November 13-25)</em>,
      <span class="series">LNCS 10629</span>,
      <span class="pages">pages 99-114</span>,
      <span class="publication-date">  <span class="year">2017</span></span>.
    </span>
    <span class="publisher">Springer.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-319-70389-3_7" data-doi="10.1007/978-3-319-70389-3_7" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-319-70389-3_7</a>
  </span>
  <a class="bibentry-link" href="#HVC17"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/CPACHECKER.html">CPAchecker</a>,
        <a class="keyword" href="../Keyword/SOFTWARE-MODEL-CHECKING.html">Software Model Checking</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-319-70389-3_7" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2017-HVC.Software_Verification_Testing_vs_Model_Checking.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="presentation-link" href="https://www.sosy-lab.org/research/prs/2017-11-15_HVC17_TestStudy_Thomas.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/presentation.gif">Presentation</a>
      <a class="material-link" href="https://www.sosy-lab.org/research/test-study/"><img alt="" height="15px" width="15px" src="https://www.sosy-lab.org/research/pub/Icons/www.gif">Supplement</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        In practice, software testing has been the established method for
        finding bugs in programs for a long time. But in the last 15 years,
        software model checking has received a lot of attention,
        and many successful tools for software model checking exist today.
        We believe it is time for a careful comparative evaluation
        of automatic software testing against automatic software model checking.
        We chose six existing tools for automatic test-case generation,
        namely AFL-fuzz, CPATiger, Crest-ppc, FShell, Klee, and PRtest,
        and four tools for software model checking, namely CBMC, CPA-Seq,
        ESBMC-incr, and ESBMC-kInd,
        for the task of finding specification violations in a large benchmark suite
        consisting of 5693 C programs. In order to perform such an evaluation,
        we have implemented a framework for test-based falsification (TBF)
        that executes and validates test cases produced by test-case generation
        tools in order to find errors in programs.
        The conclusion of our experiments is that software model checkers can
        (i) find a substantially larger number of bugs (ii) in less time,
        and (iii) require less adjustment to the input programs.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{HVC17,
        author = {Dirk Beyer and Thomas Lemberger},
        title = {Software Verification: Testing vs. Model Checking},
        booktitle = {Proceedings of the 13th Haifa Verification Conference (HVC~2017, Haifa, Israel, November 13-25)},
        editor = {O.~Strichman and R.~Tzoref-Brill},
        pages = {99-114},
        year = {2017},
        series = {LNCS~10629},
        publisher = {Springer},
        isbn = {978-3-319-70389-3},
        doi = {10.1007/978-3-319-70389-3_7},
        sha256 = {},
        url = {https://www.sosy-lab.org/research/test-study/},
        pdf = {https://www.sosy-lab.org/research/pub/2017-HVC.Software_Verification_Testing_vs_Model_Checking.pdf},
        presentation = {https://www.sosy-lab.org/research/prs/2017-11-15_HVC17_TestStudy_Thomas.pdf},
        abstract = {In practice, software testing has been the established method for finding bugs in programs for a long time. But in the last 15 years, software model checking has received a lot of attention, and many successful tools for software model checking exist today. We believe it is time for a careful comparative evaluation of automatic software testing against automatic software model checking. We chose six existing tools for automatic test-case generation, namely AFL-fuzz, CPATiger, Crest-ppc, FShell, Klee, and PRtest, and four tools for software model checking, namely CBMC, CPA-Seq, ESBMC-incr, and ESBMC-kInd, for the task of finding specification violations in a large benchmark suite consisting of 5693 C programs. In order to perform such an evaluation, we have implemented a framework for test-based falsification (TBF) that executes and validates test cases produced by test-case generation tools in order to find errors in programs. The conclusion of our experiments is that software model checkers can (i) find a substantially larger number of bugs (ii) in less time, and (iii) require less adjustment to the input programs.},
        keyword = {CPAchecker,Software Model Checking},
        annote = {Won the HVC 2017 Best Paper Award},
        }
        
      </div>
    </details>
    <details open class="annote">
      <summary>Additional Infos</summary>
      <div>
        Won the HVC 2017 Best Paper Award
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="ISOLA16a">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span> and
    <span class="author"><a href="../Author/LEMBERGER-T.html"><span class="firstname">Thomas</span> <span class="lastname">Lemberger</span></a></span>.</span>
    <span class="publication-title">Symbolic Execution with CEGAR.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">T.</span> <span class="lastname">Margaria</span></span> and
      <span class="editor"><span class="firstname">B.</span> <span class="lastname">Steffen</span></span>, editors</span>,
      <em class="booktitle">  7th International Symposium on
        Leveraging Applications of Formal Methods, Verification, and Validation
        (ISoLA 2016, Part 1, Imperial, Corfu, Greece, October 10-14)</em>,
      <span class="series">LNCS 9952</span>,
      <span class="pages">pages 195-211</span>,
      <span class="publication-date">  <span class="year">2016</span></span>.
    </span>
    <span class="publisher">Springer.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-319-47166-2_14" data-doi="10.1007/978-3-319-47166-2_14" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-319-47166-2_14</a>
  </span>
  <a class="bibentry-link" href="#ISOLA16a"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/CPACHECKER.html">CPAchecker</a>,
        <a class="keyword" href="../Keyword/SOFTWARE-MODEL-CHECKING.html">Software Model Checking</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-319-47166-2_14" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2016-ISoLA.Symbolic_Execution_with_CEGAR.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="presentation-link" href="https://www.sosy-lab.org/research/prs/2016-10-10_ISoLA16_SymbolicExecutionWithCegar_Dirk.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/presentation.gif">Presentation</a>
      <a class="material-link" href="https://www.sosy-lab.org/research/cpa-symexec/"><img alt="" height="15px" width="15px" src="https://www.sosy-lab.org/research/pub/Icons/www.gif">Supplement</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        Symbolic execution, a standard technique in program analysis,
        is a particularly successful and popular component in systems for
        test-case generation. One of the open research problems is that the approach
        suffers from the path-explosion problem. We apply abstraction to
        symbolic execution, and refine the abstract model using counterexampleguided
        abstraction refinement (CEGAR), a standard technique from model
        checking. We also use refinement selection with existing and new heuristics
        to influence the behavior and further improve the performance of our
        refinement procedure. We implemented our new technique in the open-source
        software-verification framework CPAchecker. Our experimental
        results show that the implementation is highly competitive.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{ISOLA16a,
        author = {Dirk Beyer and Thomas Lemberger},
        title = {Symbolic Execution with {CEGAR}},
        booktitle = {7th International Symposium on Leveraging Applications of Formal Methods, Verification, and Validation (ISoLA~2016, Part~1, Imperial, Corfu, Greece, October 10-14)},
        editor = {T.~Margaria and B.~Steffen},
        pages = {195-211},
        year = {2016},
        series = {LNCS~9952},
        publisher = {Springer},
        doi = {10.1007/978-3-319-47166-2_14},
        sha256 = {},
        url = {https://www.sosy-lab.org/research/cpa-symexec/},
        pdf = {https://www.sosy-lab.org/research/pub/2016-ISoLA.Symbolic_Execution_with_CEGAR.pdf},
        presentation = {https://www.sosy-lab.org/research/prs/2016-10-10_ISoLA16_SymbolicExecutionWithCegar_Dirk.pdf},
        abstract = {Symbolic execution, a standard technique in program analysis, is a particularly successful and popular component in systems for test-case generation. One of the open research problems is that the approach suffers from the path-explosion problem. We apply abstraction to symbolic execution, and refine the abstract model using counterexampleguided abstraction refinement (CEGAR), a standard technique from model checking. We also use refinement selection with existing and new heuristics to influence the behavior and further improve the performance of our refinement procedure. We implemented our new technique in the open-source software-verification framework CPAchecker. Our experimental results show that the implementation is highly competitive.},
        keyword = {CPAchecker,Software Model Checking},
        }
        
      </div>
    </details>
  </span>
</li>

</ol>
 <section id="disclaimer"> <h4>Disclaimer:</h4> <p class="disclaimer"> This material is presented to ensure timely dissemination of scholarly and technical work. Copyright and all rights therein are retained by authors or by other copyright holders. All person copying this information are expected to adhere to the terms and constraints invoked by each author's copyright. In most cases, these works may not be reposted without the explicit permission of the copyright holder. </p> </section> <footer id="generator">This file was generated by <a href="https://gitlab.com/sosy-lab/software/pybib2web/">pybib2web</a>, version 0.7.dev0</footer>